KUBERNETES(1)

NAME

kubectl run - Run a particular image on the cluster

SYNOPSIS

kubectl run [OPTIONS]

DESCRIPTION

Create and run a particular image, possibly replicated.

Creates a deployment or job to manage the created container(s).

OPTIONS

--allow-missing-template-keys=true
    If true, ignore any errors in templates when a field or map key is missing in the template. Only applies to golang and jsonpath output formats.

--attach=false
    If true, wait for the Pod to start running, and then attach to the Pod as if 'kubectl attach ...' were called. Default false, unless '-i/--stdin' is set, in which case the default is true. With '--restart=Never' the exit code of the container process is returned.

--cascade=true
    If true, cascade the deletion of the resources managed by this resource (e.g. Pods created by a ReplicationController). Default true.

--command=false
    If true and extra arguments are present, use them as the 'command' field in the container, rather than the 'args' field which is the default.

--dry-run=false
    If true, only print the object that would be sent, without sending it.

--env=[]
    Environment variables to set in the container

--expose=false
    If true, a public, external service is created for the container(s) which are run

-f, --filename=[]
    to use to replace the resource.

--force=false
    Only used when grace-period=0. If true, immediately remove resources from API and bypass graceful deletion. Note that immediate deletion of some resources may result in inconsistency or data loss and requires confirmation.

--generator=""
    The name of the API generator to use, see ⟨http://kubernetes.io/docs/user-guide/kubectl-conventions/#generators⟩ for a list.

--grace-period=-1
    Period of time in seconds given to the resource to terminate gracefully. Ignored if negative. Set to 1 for immediate shutdown. Can only be set to 0 when --force is true (force deletion).

--hostport=-1
    The host port mapping for the container port. To demonstrate a single-machine container.

--image=""
    The image for the container to run.

--image-pull-policy=""
    The image pull policy for the container. If left empty, this value will not be specified by the client and defaulted by the server

-k, --kustomize=""
    Process a kustomization directory. This flag can't be used together with -f or -R.

-l, --labels=""
    Comma separated labels to apply to the pod(s). Will override previous values.

--leave-stdin-open=false
    If the pod is started in interactive mode or with stdin, leave stdin open after the first attach completes. By default, stdin will be closed after the first attach completes.

--limits=""
    The resource requirement limits for this container. For example, 'cpu=200m,memory=512Mi'. Note that server side components may assign limits depending on the server configuration, such as limit ranges.

-o, --output=""
    Output format. One of: json|yaml|name|go-template|go-template-file|template|templatefile|jsonpath|jsonpath-file.

--overrides=""
    An inline JSON override for the generated object. If this is non-empty, it is used to override the generated object. Requires that the object supply a valid apiVersion field.

--pod-running-timeout=1m0s
    The length of time (like 5s, 2m, or 3h, higher than zero) to wait until at least one pod is running

--port=""
    The port that this container exposes. If --expose is true, this is also the port used by the service that is created.

--quiet=false
    If true, suppress prompt messages.

--record=false
    Record current kubectl command in the resource annotation. If set to false, do not record the command. If set to true, record the command. If not set, default to updating the existing annotation value only if one already exists.

-R, --recursive=false
    Process the directory used in -f, --filename recursively. Useful when you want to manage related manifests organized within the same directory.

-r, --replicas=1
    Number of replicas to create for this container. Default is 1.

--requests=""
    The resource requirement requests for this container. For example, 'cpu=100m,memory=256Mi'. Note that server side components may assign requests depending on the server configuration, such as limit ranges.

--restart="Always"
    The restart policy for this Pod. Legal values [Always, OnFailure, Never]. If set to 'Always' a deployment is created, if set to 'OnFailure' a job is created, if set to 'Never', a regular pod is created. For the latter two --replicas must be 1. Default 'Always', for CronJobs Never.

--rm=false
    If true, delete resources created in this command for attached containers.

--save-config=false
    If true, the configuration of current object will be saved in its annotation. Otherwise, the annotation will be unchanged. This flag is useful when you want to perform kubectl apply on this object in the future.

--schedule=""
    A schedule in the Cron format the job should be run with.

--service-generator="service/v2"
    The name of the generator to use for creating a service. Only used if --expose is true

--service-overrides=""
    An inline JSON override for the generated service object. If this is non-empty, it is used to override the generated object. Requires that the object supply a valid apiVersion field. Only used if --expose is true.

--serviceaccount=""
    Service account to set in the pod spec

-i, --stdin=false
    Keep stdin open on the container(s) in the pod, even if nothing is attached.

--template=""
    Template string or path to template file to use when -o=go-template, -o=go-template-file. The template format is golang templates [ ⟨http://golang.org/pkg/text/template/#pkg-overview⟩].

--timeout=0s
    The length of time to wait before giving up on a delete, zero means determine a timeout from the size of the object

-t, --tty=false
    Allocated a TTY for each container in the pod.

--wait=false
    If true, wait for resources to be gone before returning. This waits for finalizers.

OPTIONS INHERITED FROM PARENT COMMANDS

--alsologtostderr=false
    log to standard error as well as files

--application-metrics-count-limit=100
    Max number of application metrics to store (per container)

--as=""
    Username to impersonate for the operation

--as-group=[]
    Group to impersonate for the operation, this flag can be repeated to specify multiple groups.

--azure-container-registry-config=""
    Path to the file containing Azure container registry configuration information.

--boot-id-file="/proc/sys/kernel/random/boot_id"
    Comma-separated list of files to check for boot-id. Use the first one that exists.

--cache-dir="/build/.kube/http-cache"
    Default HTTP cache directory

--certificate-authority=""
    Path to a cert file for the certificate authority

--client-certificate=""
    Path to a client certificate file for TLS

--client-key=""
    Path to a client key file for TLS

--cloud-provider-gce-lb-src-cidrs=130.211.0.0/22,209.85.152.0/22,209.85.204.0/22,35.191.0.0/16
    CIDRs opened in GCE firewall for LB traffic proxy health checks

--cluster=""
    The name of the kubeconfig cluster to use

--container-hints="/etc/cadvisor/container_hints.json"
    location of the container hints file

--containerd="unix:///var/run/containerd.sock"
    containerd endpoint

--context=""
    The name of the kubeconfig context to use

--default-not-ready-toleration-seconds=300
    Indicates the tolerationSeconds of the toleration for notReady:NoExecute that is added by default to every pod that does not already have such a toleration.

--default-unreachable-toleration-seconds=300
    Indicates the tolerationSeconds of the toleration for unreachable:NoExecute that is added by default to every pod that does not already have such a toleration.

--docker="unix:///var/run/docker.sock"
    docker endpoint

--docker-env-metadata-whitelist=""
    a comma-separated list of environment variable keys that needs to be collected for docker containers

--docker-only=false
    Only report docker containers in addition to root stats

--docker-root="/var/lib/docker"
    DEPRECATED: docker root is read from docker info (this is a fallback, default: /var/lib/docker)

--docker-tls=false
    use TLS to connect to docker

--docker-tls-ca="ca.pem"
    path to trusted CA

--docker-tls-cert="cert.pem"
    path to client certificate

--docker-tls-key="key.pem"
    path to private key

--enable-load-reader=false
    Whether to enable cpu load reader

--event-storage-age-limit="default=0"
    Max length of time for which to store events (per type). Value is a comma separated list of key values, where the keys are event types (e.g.: creation, oom) or "default" and the value is a duration. Default is applied to all non-specified event types

--event-storage-event-limit="default=0"
    Max number of events to store (per type). Value is a comma separated list of key values, where the keys are event types (e.g.: creation, oom) or "default" and the value is an integer. Default is applied to all non-specified event types

--global-housekeeping-interval=1m0s
    Interval between global housekeepings

--housekeeping-interval=10s
    Interval between container housekeepings

--insecure-skip-tls-verify=false
    If true, the server's certificate will not be checked for validity. This will make your HTTPS connections insecure

--kubeconfig=""
    Path to the kubeconfig file to use for CLI requests.

--log-backtrace-at=:0
    when logging hits line file:N, emit a stack trace

--log-cadvisor-usage=false
    Whether to log the usage of the cAdvisor container

--log-dir=""
    If non-empty, write log files in this directory

--log-file=""
    If non-empty, use this log file

--log-flush-frequency=5s
    Maximum number of seconds between log flushes

--logtostderr=true
    log to standard error instead of files

--machine-id-file="/etc/machine-id,/var/lib/dbus/machine-id"
    Comma-separated list of files to check for machine-id. Use the first one that exists.

--match-server-version=false
    Require server version to match client version

--mesos-agent="127.0.0.1:5051"
    Mesos agent address

--mesos-agent-timeout=10s
    Mesos agent timeout

-n, --namespace=""
    If present, the namespace scope for this CLI request

--password=""
    Password for basic authentication to the API server

--profile="none"
    Name of profile to capture. One of (none|cpu|heap|goroutine|threadcreate|block|mutex)

--profile-output="profile.pprof"
    Name of the file to write the profile to

--request-timeout="0"
    The length of time to wait before giving up on a single server request. Non-zero values should contain a corresponding time unit (e.g. 1s, 2m, 3h). A value of zero means don't timeout requests.

-s, --server=""
    The address and port of the Kubernetes API server

--skip-headers=false
    If true, avoid header prefixes in the log messages

--stderrthreshold=2
    logs at or above this threshold go to stderr

--storage-driver-buffer-duration=1m0s
    Writes in the storage driver will be buffered for this duration, and committed to the non memory backends as a single transaction

--storage-driver-db="cadvisor"
    database name

--storage-driver-host="localhost:8086"
    database host:port

--storage-driver-password="root"
    database password

--storage-driver-secure=false
    use secure connection with database

--storage-driver-table="stats"
    table name

--storage-driver-user="root"
    database username

--token=""
    Bearer token for authentication to the API server

--update-machine-info-interval=5m0s
    Interval between machine info updates.

--user=""
    The name of the kubeconfig user to use

--username=""
    Username for basic authentication to the API server

-v, --v=0
    number for the log level verbosity

--version=false
    Print version information and quit

--vmodule=
    comma-separated list of pattern=N settings for file-filtered logging

EXAMPLE

      # Start a single instance of nginx.
      kubectl run nginx --image=nginx

      # Start a single instance of hazelcast and let the container expose port 5701 .
      kubectl run hazelcast --image=hazelcast --port=5701

      # Start a single instance of hazelcast and set environment variables "DNS_DOMAIN=cluster" and "POD_NAMESPACE=default" in the container.
      kubectl run hazelcast --image=hazelcast --env="DNS_DOMAIN=cluster" --env="POD_NAMESPACE=default"

      # Start a single instance of hazelcast and set labels "app=hazelcast" and "env=prod" in the container.
      kubectl run hazelcast --image=hazelcast --labels="app=hazelcast,env=prod"

      # Start a replicated instance of nginx.
      kubectl run nginx --image=nginx --replicas=5

      # Dry run. Print the corresponding API objects without creating them.
      kubectl run nginx --image=nginx --dry-run

      # Start a single instance of nginx, but overload the spec of the deployment with a partial set of values parsed from JSON.
      kubectl run nginx --image=nginx --overrides='{ "apiVersion": "v1", "spec": { ... } }'

      # Start a pod of busybox and keep it in the foreground, don't restart it if it exits.
      kubectl run -i -t busybox --image=busybox --restart=Never

      # Start the nginx container using the default command, but use custom arguments (arg1 .. argN) for that command.
      kubectl run nginx --image=nginx -- <arg1> <arg2> ... <argN>

      # Start the nginx container using a different command and custom arguments.
      kubectl run nginx --image=nginx --command -- <cmd> <arg1> ... <argN>

      # Start the perl container to compute π to 2000 places and print it out.
      kubectl run pi --image=perl --restart=OnFailure -- perl -Mbignum=bpi -wle 'print bpi(2000)'

      # Start the cron job to compute π to 2000 places and print it out every 5 minutes.
      kubectl run pi --schedule="0/5 * * * ?" --image=perl --restart=OnFailure -- perl -Mbignum=bpi -wle 'print bpi(2000)'

SEE ALSO

kubectl(1),

HISTORY

January 2015, Originally compiled by Eric Paris (eparis at redhat dot com) based on the kubernetes source material, but hopefully they have been automatically generated since!